package com.imanan.LiveCamera;

import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.util.List;

import android.hardware.Camera;
import android.hardware.Camera.Size;
import android.util.Log;

public class Reflect{
	private final static String LOGTAG="Reflect";
	private static Method Parameters_getSupportedPreviewSizes;
	static{
		initCompatibility();
	}
	private static void initCompatibility(){
		try{
			Parameters_getSupportedPreviewSizes = Camera.Parameters.class
				.getMethod("getSupportedPreviewSizes",new Class[]{});
		}catch(NoSuchMethodException e){
			Log.d(LOGTAG,"no such method exception");
		}
	}
	@SuppressWarnings("unchecked")
	public static List<Size> getSupportedPreviewSizes(Camera.Parameters p){
		try{
			if(Parameters_getSupportedPreviewSizes != null){
				return (List<Size>)Parameters_getSupportedPreviewSizes.invoke(p);
			}else{
				return null;
			}
		}catch(InvocationTargetException e){
			Log.e(LOGTAG,"InvocationTargetException");
			Throwable cause=e.getCause();
			if(cause instanceof RuntimeException){
				throw (RuntimeException)cause;
			}else if(cause instanceof Error){
				throw (Error)cause;
			}else{
				throw new RuntimeException(e);
			}
		}catch(IllegalAccessException e){
			Log.e(LOGTAG,"IllegalAccessException");
			return null;
		}
	}
}